#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <queue>
using namespace std;
typedef long long ll;

const ll inf = 1e9;
const int mod = 1e9 + 7;
int badV = -1;
int badF = -1;
vector<vector<int>> g;
vector<int> used;
vector<int> cmp;
vector<vector<int>> cmps;
vector<bool> bad;
vector<vector<int>> dp;
vector<int> p;
void dfs(int v) {
	used[v] = 1;
	cmp.push_back(v);
	for (auto to : g[v]) {
		if (!used[to]) {
			used[to] = 1;
			dfs(to);
		}
	}
}


void dfs2(int v) {
	used[v] = 1;
	dp[v][0] = 0;
	dp[v][1] = 1;
	for (auto to : g[v]) {
		if (!bad[to] && !used[to]) {
			dfs2(to);
			dp[v][0] += max(dp[to][1], dp[to][0]);
			dp[v][1] += dp[to][0];
		}
	}
}
void countTree(int v) {
	dfs2(v);
}
void dfs3(int v) {
	if (badV != -1) return;
	used[v] = 1;
	for (auto to : g[v]) {
		if (badV != -1) return;
		if (!used[to]) {
			p[to] = v;
			dfs3(to);
		} else if (to != p[v]) {
			badV = v;
			badF = to;
			return;
		}
	}

}
int calc_c(vector<int> a) {
	int n = a.size();
	for (auto v : a) {
		countTree(v);
	}
	int res = 0;
	if (1) {
		vector<vector<int>> dp0(n, vector<int> (2));
		dp0[0][0] = dp[a[0]][0];
		for (int i = 1; i < n; i++) {
			dp0[i][0] = max(dp0[i - 1][1], dp0[i - 1][0]) + dp[a[i]][0];
			dp0[i][1] = dp0[i - 1][0] + dp[a[i]][1];
		}
		res = max(res, max(dp0[n - 1][0], dp0[n - 1][1]));
	}
	if (1) {
		vector<vector<int>> dp0(n, vector<int> (2));
		dp0[0][0] = dp[a[0]][0];
		dp0[0][1] = dp[a[0]][1];
		for (int i = 1; i < n; i++) {
			dp0[i][0] = max(dp0[i - 1][1], dp0[i - 1][0]) + dp[a[i]][0];
			dp0[i][1] = dp0[i - 1][0] + dp[a[i]][1];
		}
		res = max(res, dp0[n - 1][0]);
	}
	return res;

}
int main() {
	int n; cin >> n;
	int k; cin >> k;
	if (n == k) {
		cout << 1 << endl;
	}
	int ans = 0;
	for (int vladloh = 0; vladloh < 2; vladloh++) {
		vector<vector<vector<int>>> dp(n + 1, vector<vector<int>> (n + 1, vector<int> (2)));
		vector<vector<vector<int>>> pref(n + 1, vector<vector<int>> (n + 2, vector<int> (2)));
		vector<vector<vector<int>>> suff(n + 1, vector<vector<int>> (n + 2, vector<int> (2)));
		dp[k][k][vladloh] = 1;
		for (int sum = 1; sum <= k; sum++) {
			for (int i = 1; i <= n + 1; i++) {
				pref[sum][i][0] = pref[sum][i - 1][0] + dp[sum][i - 1][0];
				pref[sum][i][0] %= mod;
				pref[sum][i][1] = pref[sum][i - 1][1] + dp[sum][i - 1][1];
				pref[sum][i][1] %= mod;
			}
			for (int i = n; i >= 0; i--) {
				suff[sum][i][0] = suff[sum][i + 1][0] + dp[sum][i][0];
				suff[sum][i][1] = suff[sum][i + 1][1] + dp[sum][i][1];
				suff[sum][i][0] %= mod;
				suff[sum][i][1] %= mod;
			}
		}

		for (int sum = k + 1; sum <= n; sum++) {


			for (int last = 1; last <= sum; last++) {
				if (sum == 5 && last == 4) {
					//cerr << 'd';
				}
				dp[sum][last][0] = pref[sum - last][last][1];
				dp[sum][last][1] = suff[sum - last][last + 1][0];
			}



			for (int i = 1; i <= n + 1; i++) {
				pref[sum][i][0] = pref[sum][i - 1][0] + dp[sum][i - 1][0];
				pref[sum][i][0] %= mod;
				pref[sum][i][1] = pref[sum][i - 1][1] + dp[sum][i - 1][1];
				pref[sum][i][1] %= mod;
			}
			for (int i = n; i >= 0; i--) {
				suff[sum][i][0] = suff[sum][i + 1][0] + dp[sum][i][0];
				suff[sum][i][1] = suff[sum][i + 1][1] + dp[sum][i][1];
				suff[sum][i][0] %= mod;
				suff[sum][i][1] %= mod;
			}
		}
		for (auto x : dp[n]) {
			for (auto y : x) {
				ans += y % mod;
				ans %= mod;
			}
		}
	}
	
	cout << ans << endl;
	//int mem198; cin >> mem198;
}
