#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <queue>

using namespace std;
typedef long long ll;

const ll inf = 1e9;
const int mod = 1e9 + 7;
int badV = -1;
int badF = -1;
vector<vector<int>> g;
vector<int> used;
vector<int> cmp;
vector<vector<int>> cmps;
vector<bool> bad;
vector<vector<int>> dp;
vector<int> p;
void dfs(int v) {
	used[v] = 1;
	cmp.push_back(v);
	for (auto to : g[v]) {
		if (!used[to]) {
			used[to] = 1;
			dfs(to);
		}
	}
}


void dfs2(int v) {
	used[v] = 1;
	dp[v][0] = 0;
	dp[v][1] = 1;
	for (auto to : g[v]) {
		if (!bad[to] && !used[to]) {
			dfs2(to);
			dp[v][0] += max(dp[to][1], dp[to][0]);
			dp[v][1] += dp[to][0];
		}
	}
}
void countTree(int v) {
	dfs2(v);
}
void dfs3(int v) {
	if (badV != -1) return;
	used[v] = 1;
	for (auto to : g[v]) {
		if (badV != -1) return;
		if (!used[to]) {
			p[to] = v;
			dfs3(to);
		} else if (to != p[v]) {
			badV = v;
			badF = to;
			return;
		}
	}

}
int calc_c(vector<int> a) {
	int n = a.size();
	for (auto v : a) {
		countTree(v);
	}
	int res = 0;
	if (1) {
		vector<vector<int>> dp0(n, vector<int> (2));
		dp0[0][0] = dp[a[0]][0];
		for (int i = 1; i < n; i++) {
			dp0[i][0] = max(dp0[i - 1][0] + dp[a[i]][0], dp0[i - 1][1] + dp[a[i]][1] - 1);
			dp0[i][1] = dp0[i - 1][0] + dp[a[i]][1];
		}
		res = max(res, max(dp0[n - 1][0], dp0[n - 1][1]));
	}
	if (1) {
		vector<vector<int>> dp0(n, vector<int> (2));
		dp0[0][0] = dp[a[0]][0];
		dp0[0][1] = dp[a[0]][1];
		for (int i = 1; i < n; i++) {
			dp0[i][0] = max(dp0[i - 1][0] + dp[a[i]][0], dp0[i - 1][1] + dp[a[i]][1] - 1);
			dp0[i][1] = dp0[i - 1][0] + dp[a[i]][1];
		}
		res = max(res, dp0[n - 1][0]);
	}
	return res;
}
int main() {
	int n; cin >> n;
	vector<int> a(n);
	g.resize(n);
	used.resize(n);
	bad.resize(n);
	p.resize(n);
	dp.resize(n, vector<int> (2));
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (a[i] == -1) continue;
		a[i]--;
		g[i].push_back(a[i]);
		g[a[i]].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		cmp.clear();
		if (!used[i]) {
			dfs(i);
			cmps.push_back(cmp);
		}
	}
	int ans = 0;

	for (auto cmp : cmps) {
		int rebrc = 0;
		for (auto x : cmp) {
			rebrc += g[x].size();
			used[x] = 0;
		}
		if (rebrc  == 2 * int(cmp.size()) - 2) {
			auto v = cmp.back();
			countTree(v);
			ans += max(dp[v][0], dp[v][1]);
			continue;
		}
		badV = -1;
		badF = -1;
		dfs3(cmp.back());
		for (auto x : cmp) used[x] = 0;
		vector<int> localbad;
		if (badV == -1) {
			bad[badF] = 1;
			for (int v = badV; v != badF; v = p[v]) {
				bad[v] = 1;
				localbad.push_back(v);
			}	
		localbad.push_back(badF);
		} else {
			return 0;
		}
		ans += calc_c(localbad);

	}
	cout << ans << endl;
	
}
