#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <ctime>
#include <queue>

using namespace std;
typedef long long ll;

const ll inf = 1e9;
const int mod = 1e9 + 7;
vector<vector<int>> g;
vector<int> used;
vector<int> cmp;
vector<vector<int>> cmps;
vector<bool> bad;
vector<vector<int>> dp;
void dfs(int v) {
	used[v] = 1;
	cmp.push_back(v);
	for (auto to : g[v]) {
		if (!used[to]) {
			used[to] = 1;
			dfs(to);
		}
	}
}


void dfs2(int v) {
	used[v] = 1;
	dp[v][0] = 0;
	dp[v][1] = 1;
	for (auto to : g[v]) {
		if (!bad[to] && !used[to]) {
			dfs2(to);
			dp[v][0] += dp[to][1];
			dp[v][1] += dp[to][0];
		}
	}
}
void countTree(int v) {
	dfs2(v);
}
int main() {
	int n; cin >> n;
	vector<int> a(n);
	g.resize(n);
	used.resize(n);
	bad.resize(n);
	dp.resize(n, vector<int> (2));
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		if (a[i] == -1) continue;
		a[i]--;
		g[i].push_back(a[i]);
		g[a[i]].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		cmp.clear();
		if (!used[i]) {
			dfs(i);
			cmps.push_back(cmp);
		}
	}
	int ans = 0;

	for (auto cmp : cmps) {
		int rebrc = 0;
		for (auto x : cmp) {
			rebrc += g[x].size();
			used[x] = 0;
		}
		if (rebrc  == 2 * int(cmp.size()) - 2) {
			auto v = cmp.back();
			countTree(v);
			ans += max(dp[v][0], dp[v][1]);
		}
	}
	cout << ans << endl;

}

